Program PPRAM{ Interpreter };

Uses Crt, ProcElem, InsGame;

Const
  MinusOne = -1;

Var
  Cost : Costs;

  NameProgram,  NameInput : string;

  Act : ActiveProcessors;

  NumActives : Integer;  { MinusOne, Sequential Pattern }


  {        C O N T R O L    V A R I A B L E S        }

  P : LongInt; { Instruction Pointer }

  C : array[ 0..MaxRecords - 1] of SuperRecord; { Control Record }

  Pst : ^ProgramStore; { Program Store }

  ExeTime : LongInt;


Procedure Initialize;
var i : Integer;
begin

  { Control Processor }
  P := MinProgramMemoryAddress;
  for i := 0 to MaxRecords - 1 do C[i] := 0;

  with Pe[CtrlName] do
    begin
      id:= CtrlName;
      Name := CtrlName;
      S := MinAddress;
      b := MinAddress;
    end;

  NumActives := MinusOne;

  ExeTime := 0;
  StopPoint := p;
  ActualState := TraceInto;
  Implicit := CtrlName;

  for i := p to p+2 do St^[i] := 0;

  assign( finput, '');
  reset( finput );
end;

Procedure ActiveCounter;
var i : LongInt;
begin
  NumActives := MinusOne;
  for i := 0 to MaxProcessor do
    if ( c[i div WordPRAM] and (LongInt(1) shl (i mod WordPRAM))) <> 0 then
      begin
        NumActives := NumActives+1;
        Act[NumActives] := i;
      end;
end;


function LoadProgram( Address : LongInt; n : string) : boolean;
var i: LongInt;
    FileName : text;
begin
  assign(FileName,n);
  {$i-} reset(FileName); {$i+}
  if (IOResult<>0) then
    begin
      WriteLn('Error. File not Found. ');
      LoadProgram := false;
      exit;
    end;

  i := Address;
  while not eof(FileName) do
    begin
      {$i-}read(FileName,Pst^[i]); {$i+}
      if (ioresult<>0) then begin
        WriteLn('Error reading file ',n,'. ');
        LoadProgram := false;
        exit;
      end;
      i := i+1;
    end {not eof(File)};
  If i > MaxProgramMemoryAddress then
    begin
      WriteLn('Error. Program Code Overflow Memory.');
      LoadProgram := false;
    end
  else LoadProgram := true;
  close(FileName);
end;



Procedure Openfiles;

  Procedure ReadOfCommandLine;
  begin
    NameProgram := Paramstr(1);
    if (pos('.',NameProgram)=0) then
      NameProgram := NameProgram + '.eje';
    if not LoadProgram(0,NameProgram) then
      WriteLn('Program ',NameProgram,' not Found.')
  end;

begin
  if (ParamCount > 0) then ReadOfCommandLine;
end;


Procedure LoadCosts;
label
  salirDelFor;
var
  costfile : text;
  i,j : OperationPart;

begin
  assign(costFile,'pram.cst');
  {$i-} reset(costFile) {$i+};
  if (ioResult <>0) then
    begin
      WriteLn(
      'File PRAM.CST not Found. We use unit cost.');
      for i := add2 to LastInstruction do
        Cost[i] := 1
    end
  else
    begin
      for i := add2 to LastInstruction do
        begin
          if not eof(costFile) then readln(costFile,Cost[i])
          else
            begin {el Fileero no esta completo}
              WriteLn(
              'File PRAM.CST not finishing. We use unit cost for the ',
              'follow instructions of',nc[i]);
              for j := i to LastInstruction do Cost[i] := 1
            end;
        end {for};
    end;
end;


Procedure ShowControlState;
var i : LongInt;
begin
  ShowProcessorState(CtrlName);
  WriteLn('C :'); HighVideo;

  for i := 0 to MaxRecords - 1 do
    if (i mod 2) = 1 then WriteLn(C[i]:12 )
    else Write(C[i]:12);
  NormVideo;
  WriteLn;
  Write('P : '); HighVideo; Write(p:12); NormVideo; Write(' : ');

  if ((Pst^[p]>=0) and (Pst^[p]<=ord(LastInstruction))) then
    begin
      Write(nc[OperationPart(Pst^[p])]);
      for i := 1 to disp[OperationPart(Pst^[p])]-1 do
      Write(' ',Pst^[p+i]);
    end
  else  Write('UNKNOWN');
  WriteLn;
end;

Procedure ShowState;
var
  i,Activa :  LongInt;
begin
  NormVideo;
  if wherex <> 1 then WriteLn;
  clreol;
  ShowControlState;
  Activa := 1;
  for i := 0 to NumActives do
    begin
      ShowProcessorState( Act[i] );
      Activa := Activa+1;
      if (Activa = 20) then
        begin
          WriteLn('Press <ESC> to stop. Any key to continue .');
          if (ord(readKey) = 27) then exit;
          Activa := 0;
        end;
    end;
end;


Procedure ShowProgram(Mem1,Mem2 : LongInt);
const
  ancho = 35;
var
  ins,i,j,dspl,oldIns,lonj : LongInt;
  StringChar : string[15];
begin
  ins := Mem1;
  for i := 1 to Mem2 do
    begin
      if (Pst^[ins]>ord(LastInstruction)) or (Pst^[ins]<0) then
        begin
          WriteLn(ins:6,': ',Pst^[ins]:6,' ':ancho-14,'?');
          ins := ins+1;
        end
      else
        begin
          oldIns := ins;
          str(Pst^[ins],StringChar);
          lonj := Length(StringChar)+9;
          Write(ins:6,': ',StringChar,' ');
          dspl := disp[OperationPart(Pst^[ins])];
          for j := 1 to dspl-1 do
            begin
              str(Pst^[ins+j],StringChar);
              Write(StringChar,' ');
              lonj := lonj + Length(StringChar)+1;
            end;
          ins := ins+dspl;
          Write(' ':ancho-lonj);
          ins := oldIns;
          Write(nc[OperationPart(Pst^[ins])],' ');
          dspl := disp[OperationPart(Pst^[ins])];
          for j := 1 to dspl-1 do
            Write(Pst^[ins+j],' ');
          ins := ins+dspl;
          WriteLn;
        end;
    end (* for *);
  WriteLn;
end;




  {   C O N T R O L   I N S T R U C T I O N S   }


{ Active a subrange of elemental processors }
Procedure ControlPATTERN( displ : longint );
var
  i,n1,n2 : LongInt;
begin

  PE[CtrlName].S := PE[CtrlName].S - 2;
  n1 := St^[ PE[CtrlName].S + 1];
  n2 := St^[ PE[CtrlName].S + 2] - n1;

  if n2 >= 0 then
    begin

      { It is needs to C will be initialized }
      for i := 0 to MaxRecords - 1 do C[i] := 0;

      for i := 0 to n2 do
        begin
          { We will write 1 on the bit of C asociate with the elemental processor }

          C[ i div WordPRAM ] :=
             C[ i div WordPRAM] or (LongInt(1) shl (i mod WordPRAM));

          St^[ PE[i].s + 1 ] := PE[i].Name;
          St^[ PE[i].s + 2] := PE[i].b;
          PE[i].s := PE[i].s + 2;
          PE[i].Name := i + n1;
          PE[i].b := Pe[CtrlName].B;

        end; { for }

      P := P + 3;
      ActiveCounter;

    end
  else P := P + displ;
end;

{ Active only one elemental processors }
Procedure ControlSINGLEPATTERN( Name : LongInt );
var
  i : LongInt;  { counter }
  oldb : LongInt; { B of elemental processor Name }
begin
  { It needs to C will be initialized }
  for i := 0 to MaxRecords - 1 do C[i] := 0;

  { Active one processor with name Name }
  C[name div wordPRAM] := longInt(1) shl Name;

  oldb := PE[CtrlName].b;
  St^[ PE[Name].s + 1 ] := PE[Name].Name;
  St^[ PE[Name].s + 2] := PE[Name].b;
  PE[Name].s := PE[Name].s + 2;
  PE[Name].Name := Name;
  PE[Name].b := oldb;

  P := P + 2;
  ActiveCounter;

end;

{ Active all processors with name Name }
Procedure ControlSINGLECONTROL( Name : LongInt );
var
  i : LongInt;  { counter }
  temp : LongInt;
begin
  { It needs to C will be initialized }
  for i := 0 to MaxRecords - 1 do C[i] := 0;

  for i := 0 to NumActives do
	 if PE[ Act[i] ].Name = Name then
		C[ i div WordPRAM ] :=
			C[i div WordPRAM] or (LongInt(1) shl (i mod WordPRAM));

  P := P + 2;
  ActiveCounter;

end;

{ Push the Control Record, C, on the Control Stack }
Procedure ControlPUSHPATTERN;
var i : Integer;
begin
  with Pe[CtrlName] do
    begin
      for i := 0 to MaxRecords - 1 do
       St^[S + i + 1] := C[i];
      S := S + MaxRecords;
    end;

end;


{ Active a new subrange of elemental processors when it are activing }
Procedure ControlNESTEDPATTERN( Displ : LongInt);
var
  i, j, n1, n2, Last : LongInt;
  oldB, oldNAME: array [ProcessorsRange] of LongInt;
  OverProcessors: Boolean;
begin
  { It is needs to C will be initialized }
  for i := 0 to MaxRecords - 1 do C[i] := 0;

  { Store current B and current Name of all elemental processors}
  for i := 0 to MaxProcessor do
    begin
      oldB[i] := PE[i].b;
      oldNAME[i] := PE[i].Name;
    end;

  OverProcessors := False;
  Last := 0;
  i := 0;
  while (i <= NumActives) and not OverProcessors do
    begin

      { Pop the subrange of the top to the elemental processors stack }
      PE[ Act[i] ].s := PE[ Act[i] ].s - 2;

      { To active n1..n2 elemental processors }
      n1 := St^[ PE[ Act[i] ].s + 1];
      n2 := St^[ PE[ Act[i] ].s + 2] - n1;

      ControlPUSHPATTERN;

      if n2 >= 0 then
        begin

          for j := Last to Last + n2 do
            begin
              C[ j div WordPRAM ] :=
                 C[j div WordPRAM] or (LongInt(1) shl (j mod WordPRAM));
              PE[j].Name := j + n1 - Last;
              PE[j].b := oldb[ Act[i] ];
            end;

          Last := Last + n2 + 1;
          OverProcessors := ( Last > NumProcessors);

        end;

      i := i + 1;
    end;

  if OverProcessors then
    begin
      WriteLn(#13,#10,'Overflow Number of Processors. Max > ', NumProcessors );
      ActualState := TraceInto;
    end
  else
    begin
      ActiveCounter;

      { Creating the Parallel Context }
      for j := 0 to NumActives do
        begin
          St^[ PE[ j ].s + 1 ] := oldName[ j ];
          St^[ PE[ j ].s + 2 ] := oldB[ j ]; (* ojo 15-7-92 *)
          PE[ j ].s := PE[ j ].s + 2;
        end;

     if NumActives = -1 then P := P + Displ
     else P := P + 3;

    end;
end;



{ Pop of Control Stack the Control Record, C }
Procedure ControlPOPPATTERN;
var i : Integer;
begin
  with Pe[CtrlName] do
    begin
      for i := 0 to MaxRecords - 1 do
        C[i] := St^[S - (MaxRecords - 1) + i];
      S := S - MaxRecords;
    end;
  ActiveCounter;
  P := P + 1;
end;

{ Pop of Control Stack the Control Record, C }
Procedure ControlENDPATTERN;
var i : Integer;
begin
  with Pe[CtrlName] do
      for i := 0 to MaxRecords - 1 do
        C[i] := 0;
  ActiveCounter;
  P := P + 1;
end;


{ Complement the Control Record, C }
Procedure ControlCOMPLEMENT;
var i : Integer;
begin
  for i := 0 to MaxRecords - 1 do
    C[i] := (St^[Pe[CtrlName].S - (MaxRecords - 1) + i]) xor C[i];
  ActiveCounter;
  P := P + 1;
end;

{ Copy the tops of the elemental processors stack's
  in the Control Record, C. The tops have containing zeros or ones }
Procedure ControlCOPYTOPS;
var
  i : Integer;
  t : array [0..MaxRecords - 1] of SuperRecord;
begin
  for i := 0 to MaxRecords - 1 do t[i] := 0;

  for i := 0 to NumActives do
    begin
      t[Act[i] div WordPRAM] :=
        t[Act[i] div WordPRAM] or (St^[Pe[Act[i]].s] shl Act[i]);
      Pe[Act[i]].s := Pe[Act[i]].s - 1;
    end;

  for i := 0 to MaxRecords - 1 do C[i] := t[i];
  P := P + 1;
  ActiveCounter;
end;

{ Copia los tops de la pila y complementa con respecto al registro de
  control actual. El resultado queda en el registro de control. }
Procedure ControlCOPYNOTOPS;
var
  i : Integer;
  t : array [0..MaxRecords - 1] of SuperRecord;
begin
  for i := 0 to MaxRecords - 1 do t[i] := 0;

  for i := 0 to NumActives do
    begin
      t[Act[i] div WordPRAM] :=
        t[Act[i] div WordPRAM] or (St^[Pe[Act[i]].s] shl Act[i]);
      Pe[Act[i]].s := Pe[Act[i]].s - 1;
    end;

  for i := 0 to MaxRecords - 1 do
	 C[i] := C[i] xor t[i];

  P := P + 1;
  ActiveCounter;
end;


{ Create the Stack Frame after a procedure call }
Procedure ControlPROCCALL( Level, Displ : LongInt);
var x : LongInt;
begin
  with Pe[CtrlName] do
    begin
      s := S + 1;
      x := B;
      while Level > 0 do
        begin
          x := St^[x];
          Level := Level-1;
        end;
      St^[S] := x;
      St^[S + 1] := B;
      St^[S + 2] := P + 3;
      B := S;
      S := B + 2;
    end;

  P := P + Displ;
end;


{ Retrieve the old Stack Frame when a subprogram finishing }
Procedure ControlENDPROC( ParamLength : LongInt);
begin
  with Pe[CtrlName] do
    begin
      S := B - ParamLength -1;
      P := St^[ B + 2];
      B := St^[B + 1];
    end
end;


{ Program end. }
Procedure ControlENDPROG;
begin
  WriteLn;
  ActualState := TraceInto;
  P := P + 1;
end;

{ It is equivalent to ControlPROCCALL when call the subrounding block }
Procedure ControlLOCALCALL( Displ : LongInt);
begin
  with Pe[CtrlName] do
    begin
      St^[S+1] := B;
      St^[S+2] := B;
      St^[S+3] := P + 2;
      B := S + 1;
      S := B + 2;
    end;
  P := P + Displ;
end;

{ It is equivalent to ControlPROCCALL when call the subrounding block }
Procedure ControlGLOBALCALL( Displ : LongInt);
begin
  with Pe[CtrlName] do
    begin
      St^[S+1] := St^[B];
      St^[S+2] := B;
      St^[S+3] := P + 2;
      B := S + 1;
      S := B + 2;
    end;
  P := P + Displ;
end;

{ It is equivalent to ControlPROCCALL when call the two subrounding block }
Procedure ControlGLOBALCALLTWO( Displ : LongInt);
begin
  with Pe[CtrlName] do
    begin
      St^[S+1] := St^[St^[B]];
      St^[S+2] := B;
      St^[S+3] := P + 2;
      B := S + 1;
      S := B + 2;
    end;
  P := P + Displ;
end;

{ It is equivalent to ControlPROCCALL when call the three subrounding block }
Procedure ControlGLOBALCALLTHREE( Displ : LongInt);
begin
  with Pe[CtrlName] do
    begin
      St^[S+1] := St^[St^[St^[B]]];
      St^[S+2] := B;
      St^[S+3] := P + 2;
      B := S + 1;
      S := B + 2;
    end;
  P := P + Displ;
end;

{ ControlZero = True if C = 0 else ControlZero = false }
function ControlZero : boolean;
var
  e : boolean;
  i : Integer;
begin
  e := true;
  for i := 0 to MaxRecords - 1 do
    if (C[i] <> 0) and e then e := false;
  ControlZero := e
end;

{ Change the sequential flow  }

Procedure ControlGOIFZERO( Displacement : LongInt);
begin
  if  ControlZero then  P := P + Displacement
  else P := P + 2
end;


Procedure ControlDOX( Displacement : LongInt);
begin
  with Pe[CtrlName] do
    begin
      if (St^[S] = 0) then P := P + Displacement
      else P := P + 2;
      S := S - 1;
    end
end;


Procedure ControlNOTDO( Displacement : LongInt);
begin
  with Pe[CtrlName] do
    begin
      if (St^[S] <> 0) then P := P + Displacement
      else P :=  P + 2;
      S := S - 1;
    end
end;


Procedure ControlGOIFNOZERO( Displacement : LongInt);
begin
  if  ControlZero then  P := P + 2
  else P := P + Displacement
end;



{ Simule to call instructions. }
Procedure ExeInstruction;
var i  : LongInt;
begin
  if OperationPart(Pst^[p]) < Divide2 then
    case OperationPart(Pst^[p]) of
      (* FELIX *)
      Active2   :    begin
                       ComplexActive := not ComplexActive;
                       P := P + 1;
                     end;
      (* FELIX *)
      Add2      :    begin
                       if ControlZero then add(CtrlName)
                       else
                         for i := 0 to NumActives do Add(Act[i]);
                       P := P + 1;
                     end;
      And2      :    begin
                       if ControlZero then Andx(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Andx( Act[i], Pst^[P + 1]);
                       P := P + 2;
                     end;
      AndInt2   :    begin
                       if ControlZero then AndIntx(CtrlName)
                       else
                         for i := 0 to NumActives do AndIntx( Act[i]);
                       P := P + 1;
                     end;
      Assign2   :    begin
                       (* FELIX 14.07.92 *)
                       if ComplexActive then
                         begin
                           CountParTime := CountParTime + 1;
                           if ControlZero then
                             CountSeqTime := CountSeqTime + 1
                           else { if Not ControlZero }
                             CountSeqTime := CountSeqTime + (NumActives + 1);
                         end;
                       (* FELIX 14.07.92 *)
                       if ControlZero then  Assignx(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Assignx( Act[i], Pst^[p + 1]);
                       P := P + 2;
                     end;
      Complement2 :  ControlCOMPLEMENT;
      Constant2   :  begin
                       if ControlZero then constant( CtrlName, Pst^[p+1])
		       else
			 for i := 0 to NumActives do
			   Constant(Act[i], Pst^[p + 1]);
		       P := P + 2;
		     end;
      CopyTops2   :  ControlCOPYTOPS;
      CopyNoTops2 :  ControlCopyNoTops;
      debug2      :  begin
                       if (ControlZero) then  debug(CtrlName)
                        else
                          for i := 0 to NumActives do
                            debug(Act[i]);
                        P := P + 1;
                     end;

    end {case}
  else if OperationPart(Pst^[p]) < GlobalVar2 then
    case OperationPart(Pst^[p]) of
      Divide2   :    begin
                       if ControlZero then Divide(CtrlName)
                       else
                         for i := 0 to NumActives do
                           Divide(Act[i]);
                       p := p + 1;
                     end;
      Do2       :    ControlDOX(Pst^[p+1]);
      EndBlock2 :    begin
                       if ControlZero then EndBlock(CtrlName)
                       else
                         for i := 0 to NumActives do
                           EndBlock(Act[i]);
                       p := p + 1;
                     end;
      EndNestedPATTERN2 :  begin
                             for i := 0 to NumActives do
                               PopPattern(Act[i]);
                             ControlPOPPATTERN;
                           end;
      EndPATTERN2 :  ControlENDPATTERN;
      EndProc2  :    begin
                       if ControlZero  then
                          ControlENDPROC(Pst^[p + 1])
                       else
                         begin
                           for i := 0 to NumActives do
                             EndProc(Act[i], Pst^[p+1]);
                           ControlENDPROC(0);
                         end;
                     end;
      EndProg2  :    ControlENDPROG;
      Equal2    :    begin
                       if ControlZero then Equal(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Equal(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
      EqualInt2 :    begin
                       if ControlZero then EqualInt(CtrlName)
                       else
                         for i := 0 to NumActives do EqualInt( Act[i]);
                       P := P + 1;
                     end;
      EndRelax2 :   P := P + 1;
      EndSinglePATTERN2 :   begin
                              for i := 0 to NumActives do
                                PopPattern(Act[i]);
                              ControlPOPPATTERN;
                            end;
      Field2    :    begin
                       if ControlZero then Field(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Field(Act[i], Pst^[p+1]);
                       p := p+2;
                     end;
      Fill2     :    begin
                       if ControlZero then
			 Fill(CtrlName, Pst^[p+1],Pst^[p+2],Pst^[p+3],Pst^[p+4])
		       else
			 for i := 0 to NumActives do
			   Fill(Act[i], Pst^[p+1],Pst^[p+2],Pst^[p+3],Pst^[p+4]);
		       P := P + 5;
		     end;
      Fillzero2 :    begin
	 	       if ControlZero then  Fillzero(CtrlName, Pst^[p+1])
		       else
			 for i := 0 to NumActives do
			   Fillzero(Act[i], Pst^[p+1]);
		       p := p + 2;
		     end;
      Free2     :    begin
                       if ControlZero then Free(CtrlName, Pst^[p + 1])
                       else
                         for i := 0 to NumActives do
                           Free(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
      GetTime2  :    begin
                       if (ControlZero) then  GetTimex(CtrlName)
                        else
                          for i := 0 to NumActives do
                            GetTimex(Act[i]);
                        P := P + 1;
                     end;
      GlobalCall2:  begin
                       if not ControlZero then
                         for i := 0 to NumActives do
			   GlobalCall( Act[i] );
			 ControlGLOBALCALL( Pst^[p+1] );
		     end;
 GlobalCallThree2:  begin
                       if not ControlZero then
                         for i := 0 to NumActives do
			   GlobalCallThree( Act[i] );
			 ControlGLOBALCALLTHREE( Pst^[p+1] );
		     end;
    GlobalCallTwo2:  begin
                       if not ControlZero then
                         for i := 0 to NumActives do
			   GlobalCallTwo( Act[i] );
			 ControlGLOBALCALLTHREE( Pst^[p+1] );
		     end;
      GlobalValue2 : begin
		       if ControlZero then GlobalValue(CtrlName, Pst^[p+1])
		       else
			 for i := 0 to NumActives do
			   GlobalValue(Act[i], Pst^[p+1]);
		       p := p+2;
		     end;
 GlobalValueThree2 : begin
		       if ControlZero then GlobalValueThree(CtrlName, Pst^[p+1])
		       else
			 for i := 0 to NumActives do
			   GlobalValueThree(Act[i], Pst^[p+1]);
		       p := p+2;
		     end;
   GlobalValueTwo2 : begin
		       if ControlZero then GlobalValueTwo(CtrlName, Pst^[p+1])
		       else
			 for i := 0 to NumActives do
			   GlobalValueTwo(Act[i], Pst^[p+1]);
		       p := p+2;
		     end;
    end {case}
  else if ( OperationPart( Pst^[p]) < Modulo2 ) then
    case OperationPart(Pst^[p]) of
      GlobalVar2 :   begin
                       if ControlZero then GlobalVar(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           GlobalVar(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
 GlobalVarThree2 :   begin
                       if ControlZero then GlobalVarThree(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           GlobalVarThree(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
   GlobalVarTwo2 :   begin
                       if ControlZero then GlobalVarTwo(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           GlobalVarTwo(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
      GoIfNoZero2 :  ControlGOIFNOZERO(Pst^[p +1]);
      GoIfZero2 :    ControlGOIFZERO(Pst^[p +1]);
      GoTo2     :    begin
                       if Pst^[p+1] = 0 then
                         begin
                           WriteLn(#13,#10,'Infinite Loop.');
                           ActualState := TraceInto;
                         end;
                       p := p + Pst^[p+1];
                     end;
      Greater2  :    begin
                       if ControlZero then Greater(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Greater(Act[i], Pst^[p+1]);
                       p := p+2;
                     end;
    GreaterInt2 :    begin
                       if ControlZero then GreaterInt(CtrlName)
                       else
                         for i := 0 to NumActives do GreaterInt( Act[i]);
                       P := P + 1;
                     end;
      In2       :    begin
                       if ControlZero then Inx(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Inx(Act[i], Pst^[p+1]);
                       p := p+2;
                     end;
      Index2    :    begin
                       if ControlZero then
                         Index(CtrlName, Pst^[p+1],Pst^[p+2],Pst^[p+3],Pst^[p+4])
                       else
                         for i := 0 to NumActives do
                           Index(Act[i],Pst^[p+1],Pst^[p+2],Pst^[p+3],Pst^[p+4]);
                       p := p + 5;
                     end;
      Less2     :    begin
                       if ControlZero then  Less(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Less(Act[i], Pst^[p+1]);
                       p := p+2;
                     end;
       LessInt2 :    begin
                       if ControlZero then LessInt(CtrlName)
                       else
                         for i := 0 to NumActives do LessInt( Act[i]);
                       P := P + 1;
                     end;
      LocalCall2:  begin
                       if not ControlZero then
                         for i := 0 to NumActives do
			   LocalCall( Act[i] );
			 ControlLOCALCALL( Pst^[p+1] );
		     end;
      LocalValue2 :  begin
                       if ControlZero then LocalValue( CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           LocalValue( Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
      LocalVar2 :    begin
                       if ControlZero then  LocalVar( CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           LocalVar(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
      Marked2   :    begin
		       if ControlZero then
			 Marked(CtrlName, Pst^[p+1],Pst^[p+2],Pst^[p+3],Pst^[p+4])
		       else
			 for i := 0 to NumActives do
			   Marked(Act[i], Pst^[p+1],Pst^[p+2],Pst^[p+3],Pst^[p+4]);
		       p := p + 5;
                     end;
      Max2      :    begin
	 	       if ControlZero then  Max( CtrlName)
		       else
			 for i := 0 to NumActives do
			   Max(Act[i]);
		       p := p+1;
		     end;
      Min2   :       begin
		       if ControlZero then  Minx( CtrlName)
		       else
			 for i := 0 to NumActives do
			   Minx(Act[i]);
		       p := p+1;
		     end;
      Minus2    :    begin
                       if ControlZero then Minus(CtrlName)
                       else
                         for i := 0 to NumActives do
                           Minus(Act[i]);
                       p := p+1;
                     end;
    end {case}
  else if ( OperationPart(Pst^[p]) < Pattern2) then
    case OperationPart(Pst^[p]) of
      Modulo2   :    begin
                       if ControlZero then  Modulo( CtrlName)
                       else
                         for i := 0 to NumActives do
                           Modulo(Act[i]);
                       p := p+1;
                     end;
      Multiply2 :    begin
                       if ControlZero then  Multiply( CtrlName)
                       else
                         for i := 0 to NumActives do
                           Multiply(Act[i]);
                       p := p + 1;
                     end;
      NewBlock2 :    begin
                       if ControlZero then
                         NewBlock(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           NewBlock(Act[i],Pst^[p+1]);
                       p := p + 2;
                     end;
      NestedPattern2 : begin
                         ControlPUSHPATTERN;
                         ControlNESTEDPATTERN( Pst^[ P + 1 ] );
                         (* FELIX 14.07.92 *)
                         if MaxNumberOfProcessors < (NumActives + 1) then
                           MaxNumberOfProcessors := NumActives + 1;
                         (* FELIX 14.07.92 *)
                       end;
      Not2      :    begin
                       if ControlZero then Notx(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Notx(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
       NotInt2 :     begin
                       if ControlZero then NotInt(CtrlName)
                       else
                         for i := 0 to NumActives do NotInt( Act[i]);
                       P := P + 1;
                     end;
      NotDo2    :    ControlNOTDO(Pst^[p+1]);
      NotEqual2 :    begin
                       if ControlZero then NotEqual(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           NotEqual(Act[i],Pst^[p+1]);
                       p := p + 2;
                     end;
  NotEqualInt2 :     begin
                       if ControlZero then NotEqualInt(CtrlName)
                       else
                         for i := 0 to NumActives do NotEqualInt( Act[i]);
                       P := P + 1;
                     end;
      NotGreater2 :  begin
                       if ControlZero then NotGreater(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           NotGreater(Act[i],Pst^[p+1]);
                        p := p + 2;
                     end;
  NotGreaterInt2 :   begin
                       if ControlZero then NotGreaterInt(CtrlName)
                       else
                         for i := 0 to NumActives do NotGreaterInt( Act[i]);
                       P := P + 1;
                     end;
      NotLess2  :    begin
                       if ControlZero then NotLess(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           NotLess(Act[i],Pst^[p+1]);
                       p := p+2;
                     end;
     NotLessInt2 :   begin
                       if ControlZero then NotLessInt(CtrlName)
                       else
                         for i := 0 to NumActives do NotLessInt( Act[i]);
                       P := P + 1;
                     end;
      Or2       :    begin
                       if ControlZero then  Orx(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Orx(Act[i], Pst^[p+1]);
                        p := p+2;
                     end;
         OrInt2 :   begin
                       if ControlZero then OrInt(CtrlName)
                       else
                         for i := 0 to NumActives do OrInt( Act[i]);
                       P := P + 1;
                     end;
    end {case}
  else if (OperationPart(Pst^[p]) < SimpleAssign2) then
    case OperationPart(Pst^[p]) of
      Pattern2  : begin
                    
                    ControlPATTERN( Pst^[P + 1] );
                    (* FELIX 14.07.92 *)
                    if MaxNumberOfProcessors < (NumActives + 1) then
                      MaxNumberOfProcessors := NumActives + 1;
                    (* FELIX 14.07.92 *)
                  end;
      PopPattern2 :  ControlPOPPATTERN;

      privateAssign2 :begin
                       (* FELIX 14.07.92 *)
                       if ComplexActive then
                         begin
                           CountParTime := CountParTime + 1;
                           if ControlZero then
                             CountSeqTime := CountSeqTime + 1
                           else { if Not ControlZero }
                             CountSeqTime := CountSeqTime + (NumActives + 1);
                         end;
                       (* FELIX 14.07.92 *)
                       if ControlZero then  Assignx(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Assignx( Act[i], Pst^[p + 1]);
                       P := P + 2;
                     end;

      privateGetTime2:begin
                       if (ControlZero) then  GetTimex(CtrlName)
                        else
                          for i := 0 to NumActives do
                            GetTimex(Act[i]);
                        P := P + 1;
                     end;

      privateReadInt2:begin
                       Readx;
                       p := p + 1;
                     end;

      privateSetTime2:begin
                       if (ControlZero) then  SetTimex(CtrlName)
                        else
                          for i := 0 to NumActives do
                            SetTimex(Act[i]);
                        P := P + 1;
                     end;

      privateSimpleAssign2:begin
                        (* FELIX 14.07.92 *)
                        if ComplexActive then
                          begin
                            CountParTime := CountParTime + 1;
                            if ControlZero then
                              CountSeqTime := CountSeqTime + 1
                            else { if Not ControlZero }
                              CountSeqTime := CountSeqTime + (NumActives + 1);
                          end;
                        (* FELIX 14.07.92 *)
                        if (ControlZero) then  SimpleAssign(CtrlName)
                        else
                          for i := 0 to NumActives do
                            SimpleAssign(Act[i]);
                        p := p + 1;
                      end;

      ProcCall2 :    begin
                       if not ControlZero then
                           for i := 0 to NumActives do
                             ProcCall(Act[i], Pst^[p + 1]);
                       ControlPROCCALL(Pst^[p+1], Pst^[p+2]);
                     end;
      Procedure2 :   begin
                       if PE[CtrlName].S + Pst^[P+2] > MaxMemoryControlAddress then
                         Error( CtrlName, Implicit ,' Control Stack Overflow.');
                       if ControlZero then
                         Procedurex(CtrlName,Pst^[P+1])
                       else
                         for i := 0 to NumActives do
                         begin
                           if ( PE[act[i]].s + Pst^[P+1] + Pst^[P+3]> PE[act[i]].StackBottom + LocalStackSize )then
                             Error( Act[i], Implicit ,' Elemental Processor Stack Overflow.');
                           Procedurex(Act[i] , Pst^[P+1] );
                         end;
                        P := P + Pst^[P+4];
                     end;
      Program2  :    begin
                       (* This instruction is executing by all elemental processors *)
                       Pe[CtrlName].S := 2 + Pst^[P+1];
                       Pe[CtrlName].B := 0;

                       (* Memory Work, "St", division *)
                       MemoryControlSize := Pst^[P+2]*10;
                       MinMemoryControlAddress := 0;
                       MaxMemoryControlAddress := MemoryControlSize - 1;
                       FreeMemory := MemorySize - (MemoryControlSize + 1);
                       LocalStackSize := FreeMemory div NumProcessors;

                       if LocalStackSize < Pst^[P+3] then
                         begin
                           WriteLn('Error. Stack of Elemental Processors Insufficient. ');
                           ActualState := TraceInto;
                         end;

                       for i := 0 to MaxProcessor do
                         Programx(i, i);

                       (* The program start in  P+4 *)
                       P := P + Pst^[P+4];

                       (* Control Record <- Secuencial Pattern *)
                       for i := 0 to MaxRecords - 1 do C[i] := 0;
                       (* Only Active Control Processor *)
                       NumActives := -1;

                       (* FELIX 14.07.92 *)
                       MaxNumberOfProcessors := 1;
                       CountSeqTime := 0;
                       CountParTime := 0;
                       ComplexActive := True;
                       (* FELIX 14.07.92 *)
                     end;
      PushName2 :    begin
                       if ControlZero then
                         begin
                           WriteLn('Be Carefully!. Control try to do PushName!');
                           ActualState := TraceInto;
                         end
                         else
                           for i := 0 to NumActives do
                             PushName(Act[i], Pst^[p+1]);
                         p := p + 2;
                     end;
      PushPattern2 : begin
                       ControlPUSHPATTERN;
                       P := P + 1;
                     end;
      Random2    : begin
	                 if ControlZero then
                         Randomx(CtrlName, Pst^[P+1])
                       else
                         for i := 0 to NumActives do
                           Randomx(Act[i],Pst^[P+1]);
                        P := P + 2;
                   end;
      Randomize2 : begin
	                 if ControlZero then
                         Randomizex( CtrlName)
                       else
                         for i := 0 to NumActives do
                           Randomizex( Act[i]);
                        P := P + 1;
	               end;
      ReadInt2   :   begin
                       Readx;
                       p := p + 1;
                     end;
      Readlnx2   :   begin
                       Readlnx;
                       p := p + 1;
                     end;
      Relax2     :   P := P + 1;
      SetTime2  :    begin
                       if (ControlZero) then  SetTimex(CtrlName)
                        else
                          for i := 0 to NumActives do
                            SetTimex(Act[i]);
                        P := P + 1;
                     end;
      Shared2    :   P := P + 2;
       Shl2      :   begin
                       if (ControlZero) then Shlx(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Shlx(Act[i], Pst^[p+1]);
                       p := p + 2;
                     end;
        shlInt2 :   begin
                       if ControlZero then shlInt(CtrlName)
                       else
                         for i := 0 to NumActives do shlInt( Act[i]);
                       P := P + 1;
                     end;
       Shr2      :   begin
                       if (ControlZero) then Shrx(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Shrx(Act[i],Pst^[p+1]);
                       p := p + 2;
                     end;
        shrInt2 :   begin
                       if ControlZero then shrInt(CtrlName)
                       else
                         for i := 0 to NumActives do shrInt( Act[i]);
                       P := P + 1;
                     end;
    end {case}
  else if (OperationPart(Pst^[p]) <= XorInt2) then
    case OperationPart(Pst^[p]) of
      SimpleAssign2 : begin
                        (* FELIX 14.07.92 *)
                        if ComplexActive then
                          begin
                            CountParTime := CountParTime + 1;
                            if ControlZero then
                              CountSeqTime := CountSeqTime + 1
                            else { if Not ControlZero }
                              CountSeqTime := CountSeqTime + (NumActives + 1);
                          end;
                        (* FELIX 14.07.92 *)
                        if (ControlZero) then  SimpleAssign(CtrlName)
                        else
                          for i := 0 to NumActives do
                            SimpleAssign(Act[i]);
                        p := p + 1;
                      end;
      SimpleValue2 : begin
                       if (ControlZero) then SimpleValue(CtrlName)
                       else
                         for i := 0 to NumActives do
                           SimpleValue(Act[i]);
                        p := p + 1;
							end;
	 SingleControl2 : ControlSINGLECONTROL( Pst^[P+1] );
	 SinglePattern2 : begin
                          ControlPushPattern;
                          ControlSINGLEPATTERN( Pst^[P+1] );
                          end;
		Subtract2 :    begin
                       if (ControlZero) then Subtract(CtrlName)
                       else
                         for i := 0 to NumActives do
                           Subtract(Act[i]);
                       p := p + 1;
                     end;
      Value2    :    begin
                       if (ControlZero) then Value(CtrlName, Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Value(Act[i],Pst^[p+1]);
                        p := p + 2;
                     end;
      Variable2 :    begin
                       if (ControlZero) then
                         Variable(CtrlName,Pst^[p+1],Pst^[p+2])
                       else
                         for i := 0 to NumActives do
                           Variable(Act[i],Pst^[p+1],Pst^[p+2]);
                       p := p + 3;
                     end;
      VarParam2 :    begin
                       if (ControlZero) then
                         VarParam(CtrlName,Pst^[p+1],Pst^[p+2])
                       else
                         for i := 0 to NumActives do
                           VarParam(Act[i], Pst^[p+1],Pst^[p+2]);
                       p := p + 3;
                     end;
      WriteInt2 :    begin
      				   if ControlZero then
                         WriteIntx(CtrlName)
					   else
                         for i := 0 to NumActives do
					       WriteIntx(Act[i]);
                       p := p + 1;
                     end;
      WriteStr2 :    begin
       				   if ControlZero then
                         WriteStr(CtrlName, Pst^[p + 1], Pst^[p + 2])
                       else
                         for i := 0 to NumActives do
                           WriteStr(Act[i], Pst^[p + 1], Pst^[p + 2]);
                       p := p + 3;
                     end;
      Xor2      :    begin
                       if (ControlZero) then Xorx(CtrlName,Pst^[p+1])
                       else
                         for i := 0 to NumActives do
                           Xorx(Act[i],Pst^[p+1]);
                       p := p + 2;
                     end;
        xorInt2 :   begin
                       if ControlZero then xorInt(CtrlName)
                       else
                         for i := 0 to NumActives do xorInt( Act[i]);
                       P := P + 1;
                     end;
    end (* case *)
  else
    begin
      Write(#13,#10,
      'Code instruction unknown : ',(Pst^[p]),'.',#13,#10,'p = ',p,' c = ');
      for i := 0 to MaxRecords - 1 do Write(c[i], '| ');
      WriteLn;
      Write(' s = ',Pe[CtrlName].s,
            ' ssr[',Pe[CtrlName].s,'] = ',St^[Pe[CtrlName].s] );
      ActualState := TraceInto;
    end;
 end {ExeInstruction};


Procedure RunInstruction;
var
  Op : OperationPart;
begin

  Op := OperationPart(Pst^[p]);
  if ( 0 <= Pst^[p]) and ( Pst^[p] <= ord(LastInstruction)) then
    begin
      ExeInstruction;
      ExeTime := ExeTime + 1;
    end
  else
    begin
      WriteLn('Error. Executar this instruction is imposible. ');
      ActualState := TraceInto;
    end;

  if (P < MinProgramMemoryAddress) or (p > MaxProgramMemoryAddress) then
    begin
      WriteLn( 'Illegal  P  value.');
      ShowState;
      ActualState := TraceInto;
      exit;
    end;
  if (Pe[CtrlName].s < minMemoryControlAddress) or
     (Pe[CtrlName].s > MaxMemoryControlAddress) then
    begin
      WriteLn( 'Stack Control overflow.');
      ShowState;
      ActualState := TraceInto;
      exit;
    end;

  { Controlar los desbordamientos de las pilas
    de los Procesadores elementales  }

end;



{       A N A L I S I S      D E    C O M A N D O S         }


Procedure Filler(Address : LongInt);
var
  StringChar : string;
  Num,Err : Integer;
begin
  while true do
    begin
      Write(Address:6,' : ');
      if (Implicit = CtrlName) then Write(St^[Address]:12,': ')
      else Write(St^[Address]:12,': ');
      ReadLine(StringChar);
      if StringChar = '' then exit;
      Val( StringChar,Num,Err);
      if Err=0 then
        begin
          if Implicit = CtrlName then St^[Address] := Num
          else St^[Address] := Num;
          Address := Address+1;
        end;
    end;
end;


Procedure Assembly( Address : LongInt);
  label Continue;
  var
    Cont, OldAddress, NumArguments, Argument, Sign : LongInt;
    Code, Line : string;
    Cod : LongInt;

  function Index(s : string20) : LongInt;
    var n,m,k : LongInt;
    begin
      m := 0;
      n := ord(LastInstruction);
      k := n div 2;
      while (m <= n) do
        begin
          k := (m+n) div 2;
          if nc[OperationPart(k)] = s then
            begin
              Index := k;
              exit;
            end
          else if nc[OperationPart(k)] < s then m := k+1
          else n := k-1;
        end {while};
      Index := -1;
    end {Index};

  Procedure EatSpace;
  begin
    while (Cont <= Length(Line)) and ( Line[Cont] in [' ',#9]) do
      Cont := Cont+1;
  end;

begin {Assembly}
  while true do
    begin
      Continue:
      OldAddress := Address;
      Write(Address:6,': '); ReadLine(Line);
      if Line = '' then exit;
      Cont := 1;
      Code := '';
      EatSpace;
      while (Cont <= Length(Line)) and
            (upCase(Line[Cont]) in ['A'..'Z']) do
        begin
          Code := Code+upCase(Line[Cont]);
          Cont := Cont+1;
        end;
      Cod := Index(Code);
      if (Cod <> -1) then
        begin
          Pst^[Address] := ord(Cod); Address := Address+1;
          EatSpace;
          NumArguments := 0;
          while (Cont <= Length(Line)) and
                (Line[Cont] in ['-','+','0'..'9']) do
            begin
              Argument := 0; Sign := 1;
              if (Line[Cont] in ['+','-']) then
                begin
                  if (Line[Cont] = '-') then Sign := -1;
                  Cont := Cont+1;
                  if not(Line[Cont] in ['0'..'9']) then
                    begin
                      WriteLn('^':Cont+7,' Sign Error.');
                      Address := OldAddress;
                      goto Continue;
                    end;
                end;
              while (Cont <= Length(Line)) and
                    (Line[Cont] in ['0'..'9']) do
                begin
                  Argument := Argument*10+ord(Line[Cont])-ord('0');
                  Cont := Cont+1;
                end;
              NumArguments := NumArguments+1;
              Pst^[Address] := Sign*Argument;
              Address := Address+1;
              EatSpace;
            end (* all arguments read *);
        end (* de Cod <> -1 *)
      else  (* Cod = -1 *)
        begin
          WriteLn('^':7+Cont,' Unknow Code.');
          Address := OldAddress;
          goto Continue;
        end;
      if (NumArguments <> disp[OperationPart(Cod)]-1) then
        begin
          WriteLn('^':7+Cont,' Error Numbers Arguments. ',
          #13,#10,
          'La instruccin ',nc[OperationPart(Cod)],
          ' debe tener ',disp[OperationPart(Cod)]-1,' Argument(s). ');
          Address := OldAddress;
        end;
    end;
end {Assembly};



Procedure DebugCommandAnalysis;
var
  i, PosSemicolon, ForLine : Integer;
  Err : Integer;
  StringChar, Line : string;
  FileName : text;
  Op : OperationPart;
  Mem1, Mem2, Num : Word;
begin
  Line := '';
  NormVideo;
  while (Line = '') do
    begin
      if (Implicit = CtrlName) then Write('CONTROL|T',ExeTime,'>')
      else Write('P',Implicit,'|T',ExeTime,'>');
      ReadLine(Line);
    end;
  Val(Line , Num, Err);
  if Err = 0 then
    begin
      if (Num >= 0) and (Num <= MaxProcessor) then
        ShowProcessorState(Num)
      else WriteLn('There aren''t Processor ', Num ,'.');
      exit;
    end;
  if ( Copy(Line,1,6) = 'ACTIVE') then
    begin
      Write('[ ');
      for i := 0 to NumActives do  Write(Act[i],' ');
      Write('] ');
      WriteLn;
    end
  else if ( Copy(Line,1,3) = 'IMP') then
    begin
      Line := Copy(Line,4,Length(Line)-3);
      Val( Line, Implicit, Err);
      if ( Err <> 0 ) and (Line = ' CONTROL') then Implicit := CtrlName
      else if Err <> 0 then
        begin
          Implicit := CtrlName;
          WriteLn(ErrorMessages[ImpError]);
        end
    end
  else if ( Copy(Line,1,7) = 'CONTROL') then  ShowControlState
  else if ( Copy(Line,1,3) = 'ASS') then
    begin
      Val( Copy(Line,5,Length(Line)-4), Num, Err);
      if ( Err <> 0 ) then WriteLn(ErrorMessages[AssemError])
      else  Assembly( Num );
    end
  else if ( Copy(Line,1,4) = 'SAVE' ) then
    begin
      Line := Copy(Line,6,Length(Line)-5);
      PosSemicolon := pos(',',Line);
      Val( Copy(Line,1,PosSemicolon-1), Mem1 , Err);
      if ( Err <> 0 ) then WriteLn(ErrorMessages[SaveError])
      else
        begin
          Line := Copy(Line,PosSemicolon+1,Length(Line)-PosSemicolon);
          PosSemicolon := pos(',',Line);
          Val( Copy(Line,1,PosSemicolon-1), Mem2, Err);
          if (Err<>0) then
            begin
              Line := Copy(Line,PosSemicolon+1,Length(Line)-PosSemicolon);
              if (pos(Line,'.')=0) then Line := Line+'.eje';
              assign(FileName,Line);
              {$i-} reset(FileName); {$i+}
              if (ioresult<>0) then reWrite(FileName)
              else
                begin
                  WriteLn('File ',Line,' exist. Append dates...');
                  apPend(FileName);
                end;
              for i := Mem1 to Mem2 do
                Write(FileName,Pst^[i],' ');
              close(FileName);
              WriteLn('Loaded.');
            end
          else WriteLn(ErrorMessages[SaveError]);
        end
    end
  else if ( Copy(line,1,5) = 'INPUT') then
    begin
      Line := Copy(Line, 7, Length(line)-6);
      close( finput );
      assign( finput, Line );
      {$I-}
      Reset(finput);
      {$I+}
      if IOResult <> 0 then
        begin
          writeln( 'Data File not Found.');
          assign(finput, '');
          reset(finput);
        end;
    end
  else if ( Copy(Line,1,4) = 'LOAD') then
    begin
      Line := Copy(Line,6,Length(Line)-5);
      PosSemicolon := pos(',',Line);
      Val( Copy(Line,1,PosSemicolon-1), Num, Err);
      if ( Err <> 0 ) then WriteLn(ErrorMessages[LoadError])
      else
        begin
          Line := Copy(Line,PosSemicolon+1,Length(Line)-PosSemicolon);
          if not boolean(pos('.',Line)) then Line := Line+'.eje';
          if LoadProgram( Num, Line ) then WriteLn('Loaded.')
          else WriteLn('Failure Load.');
        end
    end
  else if (Copy(Line,1,3) = 'REC') then
    begin
      Line := Copy(Line,5,Length(Line)-4);
      case (upCase(Line[1])) of
       'B' : begin
               Write('B: ',Pe[Implicit].b:6,' : ');
               ReadLine(StringChar);
               Val(StringChar,Num,Err);
               if Err=0 then Pe[Implicit].b := Num;
             end;
       'C' : begin
               Write('C: ');
               for i := 0 to MaxRecords - 1 do
                 Write(c[i]:12,' | ');
               WriteLn;
               ReadLine(StringChar);
               if Length(StringChar) = 0 then exit;
               StringChar := StringChar + ',';
               for i := 0 to MaxRecords - 1 do
                 begin
                   PosSemicolon := pos(',',StringChar);
                   if boolean(PosSemicolon) then
                     begin
                       Val(Copy(StringChar,1,PosSemicolon -1),Num,Err);
                       StringChar := Copy(StringChar, PosSemicolon + 1, Length(StringChar));
                       if Err = 0 then C[i] := Num
                     end
                   else WriteLn(ErrorMessages[ControlRecordError]);
                 end;
               ActiveCounter;
             end;
       'P' : begin
               Write('P: ',p:6,' : ');
               ReadLine(StringChar);
               Val(StringChar,Num,Err);
               if Err=0 then p := Num;
             end;
       'S' : begin
               if (Implicit = CtrlName) then
                 begin
                   Write('CONTROL S: ',Pe[CtrlName].s:12,' : ');
                   ReadLine(StringChar);
                   Val(StringChar, Num, Err);
                   if Err=0 then Pe[CtrlName].s := Num;
                 end
               else
                 begin
                   Write('PROCESSOR ',Implicit:6,' S: ',Pe[Implicit].s:6,' : ');
                   ReadLine(StringChar);
                   Val(StringChar, Num, Err);
                   if Err=0 then Pe[Implicit].s := Num;
                 end;
             end
       else WriteLn(ErrorMessages[RecordError])
      end (*case*);
    end
  else if ( Copy( Line, 1, 2) ='GO') then ActualState := LetGo
  else  if ( Copy( Line, 1, 4) = 'FILL') then
    begin
      Val( Copy(Line,6,Length(Line)-5), Num, Err);
      if ( Err <> 0 ) then WriteLn(ErrorMessages[FillError])
      else  Filler(Num);
    end
  else if ( Copy(Line, 1, 4) = 'TIME') then
    begin
      Write('TIME :', ExeTime,': ');
      ReadLine(StringChar);
      Val( StringChar, Num, Err);
      if ( Err <> 0 ) then  exit
      else  ExeTime := Num;
    end
  else if ( Copy(Line, 1, 5) = 'TRACE') then
    begin
      Op := OperationPart(Pst^[p]);
      if ( 0 <= ord(Op) ) and ( Op <= LastInstruction) then
        begin
          RunInstruction;
          Op := OperationPart(Pst^[p]);
          ShowState;
        end
      else  WriteLn('Error. It''s not possible carry out this instruction');
    end
  else if ( Copy(Line, 1, 3) = 'INI') then Initialize
  else  if ( Copy(Line, 1, 7) = 'PROGRAM') then
    begin
      Line := Copy(Line, 8, Length(Line)-7);
      PosSemicolon := pos(',',Line);
      Val( Copy(Line,1,PosSemicolon-1), Mem1, Err);
      if (Err <> 0) then Mem1 := 0;
      Val( Copy(Line,PosSemicolon+1,Length(Line)-PosSemicolon), Mem2, Err);
      if (Err <> 0) then Mem2 := 1;
      ShowProgram( Mem1, Mem2);
      if (Err <> 0) then WriteLn(ErrorMessages[ProgramError]);
    end
  else if ( Copy( Line, 1, 3) = 'MEM') then
    begin
      ForLine := 5;
      Line := Copy( Line, 5, Length(Line));
      PosSemicolon := pos(',',Line);
      Val( Copy(Line,1,PosSemicolon-1), Mem1, Err);
      if Err = 0 then
        begin
          Val( Copy(Line,PosSemicolon+1,Length(Line)-PosSemicolon), Mem2, Err);
          if Err = 0 then
            begin
              if Mem2 < Mem1 then
              WriteLn('Error. The second number must be greater than First.');
              for i := Mem1 to Mem2 do
                begin
                  if ((i-Mem1) mod ForLine) = 0 then Write(#13,#10,i:6,': ');
                  if (Implicit = CtrlName) then Write(St^[i]:11,' ')
                  else Write(St^[i]:6,' ');
                end;
            end;
        end;
      if  Err <> 0  then WriteLn(ErrorMessages[MemError]);
      WriteLn;
    end
  else if ( Copy(Line,1, 4) = 'QUIT') then halt(0)
  else if (Copy(Line, 1, 4) = 'MAKE') then
    begin
      Op := OperationPart(Pst^[p]);
      if (Op in JumpIns) then
        begin
          RunInstruction;
          ShowState;
        end
      else if ( 0 <= ord(Op)) and (Op <= LastInstruction) then
        begin
          ActualState := StepOver;
          StopPoint := p + disp[Op];
        end
      else WriteLn('Error. It''s not possible carry out this instruction');
    end
  else if ( Copy( Line, 1, 5) = 'UNTIL') then
    begin
      Val( Copy( Line, 6, Length(Line)-5), StopPoint, Err);
      if  Err <> 0  then WriteLn( ErrorMessages[UntilError])
      else  ActualState := StepOver;
    end
  else if ( Copy( Line, 1, 7) = 'COMPLEX' ) then
    begin
      writeln('MaxProcessor : ', MaxNumberOfProcessors,
              ' Seq Time : ', CountSeqTime,
              ' Par Time : ', CountParTime )
    end
  else
    begin
      WriteLn('Commands:',#13,#10,
      '<NUMBER> | ACTIVE | LOAD | CONTROL | ASS | MAKE | IMP | INI | GO | ',
      #13,#10,
      'UNTIL | FILL | MEM | PROGRAM | REC | QUIT | SAVE | TIME | TRACE |',
      #13,#10,
      'INPUT | COMPLEX ' );
    end
end;


Procedure Debug;
begin
  while true do
    begin
      if (ActualState = LetGo) then exit;
      if (ActualState = StepOver) then
        begin
          if ( p <> StopPoint) then exit;
          ShowState;
          ActualState := TraceInto;
        end;
      DebugCommandAnalysis;
    end;
end;




Procedure RunProgram;
begin
  Initialize;
  OpenFiles;
  while true do
    begin
      Debug;
      RunInstruction;
    end (* while true *);
  close(finput);
end;



{      P R O G R A M A      P R I N C I P A L       }

begin
  WriteLn(#13,#10);
  HighVideo;
  Write('P');
  NormVideo;
  Write('arallel ');
  HighVideo;
  Write('R');
  NormVideo;
  Write('andom ');
  HighVideo;
  Write('A');
  NormVideo;
  Write('ccess ');
  HighVideo;
  Write('M');
  NormVideo;
  WriteLn('achine. ( Versin 3.1 del 23.12.93 ) ');
  writeln('Pattern-EndPattern: NestedPatter-EndNesttedPattern');
  writeln('SinglePattern-EndSinglePattern');
  writeln('Private : Assign-SimpleAssign | ReadInt | settime-gettime');
  writeln('Shared ');
  New(St);
  New(Pst);
  RunProgram;
end.






